package ExStockData.Graph;

import java.util.Arrays;
import java.util.ArrayList;

import java.io.File;
import java.io.FileReader;
import java.io.BufferedReader;

public class Popularity {
    public Popularity() {}
    
    public long[] calcPopularityByObjNum(String[][] obj, int index) {
    	String[] output = new String[obj.length];
    	for(int i = 0; i<obj.length; i++) {
	    output[i] = obj[i][index];
	}
	return calcPopularityByObjNum(output);
    }
    
    public long[] calcPopularityByObjNum(String[] obj) {
	int index;
	ArrayList p = new ArrayList();
	long[] sorted;
	long[] popularity;
	
	for(int i = 0; i<obj.length; i++) {
	    if(!p.contains(obj[i]))
		p.add(obj[i]);
	}
	
	sorted = new long[p.size()];
	for(int i = 0; i<p.size(); i++) {
	    sorted[i] = Integer.parseInt((String)p.get(i));
	}
	Arrays.sort(sorted);
	
	p = new ArrayList();
	for(int i = 0; i<sorted.length; i++) {
	    p.add(String.valueOf(sorted[i]));
	}
	
	popularity = new long[p.size()];
	
	for(int i = 0; i<obj.length; i++) {
	    index = p.indexOf(obj[i]);
	    popularity[index]++;
	}
	
	return popularity;
    }        
    
    public long[] calcPopularityByObjNum(File file) {
	
    	ArrayList arr = new ArrayList();      		
    	ArrayList p = new ArrayList();
    	
	BufferedReader in = null;
	
        int index = 0;
        int sizing = 0;
        int temp;
	
       	try {
	    in = new BufferedReader(new FileReader(file));
	    do {
		
		String s = in.readLine();
		if(s == null) break;
		
		temp = 0;
		
		index = Integer.parseInt(s);
		if(!arr.contains(s)) {
		    arr.add(s);    			
		    sizing = index-p.size()+1;
		    
		    for(int j = 0; j<sizing; j++)
			p.add(new Integer(0));
		}
		Integer count = (Integer)p.get(index);
		temp = count.intValue();
		temp++;
		p.set(index, new Integer(temp));
		
	    } while (true);
	    
    	} catch (Exception ee) {
	    ee.printStackTrace();
    	}
	
	/* // remove items that has 0 popularity    	
    	for(int i = 0; i<p.size(); i++) {
    		temp = ((Integer)p.get(i)).intValue();
    		if(temp == 0) {
    			p.remove(i);
    			i--;
    		}
    	}
    	*/
    	
	long[] popularity = new long[p.size()];
	
	for(int i = 0; i<p.size(); i++) {
	    index = ((Integer)p.get(i)).intValue();
	    popularity[i] = index;
	}
	
	return popularity;
    }    
    
    public long[] calcPopularity(String[][] obj, int index) {
    	String[] output = new String[obj.length];
    	for(int i = 0; i<obj.length; i++) {
	    output[i] = obj[i][index];
	}
	return calcPopularity(output);
    }
    
    public long[] calcPopularity(String[] obj) {
	int index;
	ArrayList p = new ArrayList();
	long[] popularity;
	
	for(int i = 0; i<obj.length; i++) {
	    if(!p.contains(obj[i]))
		p.add(obj[i]);
	}
	
	popularity = new long[p.size()];
	
	for(int i = 0; i<obj.length; i++) {
	    index = p.indexOf(obj[i]);
	    popularity[index]++;
	}
	
	Arrays.sort(popularity);
	
	return popularity;
    }        
    
}
