package ExStockData.XML;

import javax.swing.JOptionPane;
import javax.swing.JDialog;

import javax.swing.JTextField;
import javax.swing.JPanel;
import javax.swing.JFrame;

import ExStockData.Graph.ListView;
import ExStockData.XML.XMLStream;

import org.w3c.dom.Document;
import org.w3c.dom.NodeList;
import org.w3c.dom.Node;

import java.io.File;
import java.io.FileWriter;
import java.io.FileReader;
import java.io.IOException;

import java.util.Calendar;
import java.util.TimeZone;
import java.util.StringTokenizer;

import java.text.SimpleDateFormat;



public class StreamDialog {
    private final String DATE_FORMAT = "HH:mm:ss.SSS";
    private String token = "";
    public String stock = "MSFT";
    public String bufferSize = "100";
    public JOptionPane optionPane;
    private JFrame parent;
    private JTextField stockField;
    private JTextField bufferSizeField;
    private ListView list;
    private XMLStream xmls;
    private String type;	
    private String stype;
    private String stockString;
    private Document document;
    private String[][] data;
    
    public StreamDialog(JFrame parent) {
    	this.parent = parent;
    	try {
	    FileReader tok = new FileReader("ini//token.ini");
	    int cha = 0;
	    while(cha>=0) {
		cha = tok.read();
		token += (char)cha;
	    }
	} catch (Exception e) { e.printStackTrace(); }
	token = token.trim();
    }
    
    public boolean getDayStock() {
	//http://xml.island.com/ws/xml/timeandsales.xml?token=[token]&symbol=[symbol]&time=[HH:MM:SS.mmm]
	//http://xml.island.com/ws/xml/timeandsales.xml?token=XAxrQjJZRANPHZ2x&symbol=CSCO&time=16:22:53.269
	bufferSize = "500";
	
	stockString = "http://xml.island.com/ws/xml/toplist.xml?token="
	    + token + "&recNumb=" + bufferSize + "&sort=matchedShares&list=all";
	
        xmls = new XMLStream(parent);     	
        try {
	    document = xmls.openStream(stockString);
        } catch (Exception exc) {
	    exc.printStackTrace();
        }
        
        if(document == null) return false;
        getTopListData();
	
	Calendar cal = Calendar.getInstance(TimeZone.getDefault());
	SimpleDateFormat sdf = new SimpleDateFormat(DATE_FORMAT);
	sdf.setTimeZone(TimeZone.getDefault());
	
	String timeStr = sdf.format(cal.getTime());
	
	return getDayStockData(timeStr);
    }	
    
    private boolean getDayStockData(String timeStr) {
    	int recNumb = 0;
    	String tStr = "";
    	FileWriter fw;
    	String[] allStock = new String[data.length];
	
    	for(int i = 0; i<data.length; i++)
	    allStock[i] = data[i][0];
    	
    	for(int i = 0; i<timeStr.length(); i++) {
	    if(timeStr.charAt(i) != ':'
	       && timeStr.charAt(i) != '.')
    		tStr += timeStr.charAt(i);
    	}
    	
	File dir = new File("stockdata");
	if(dir.exists()) {
	    if(!dir.isDirectory()) {
		dir.delete();
		dir = new File("stockdata");
		dir.mkdir();
	    }
	} else {
	    dir.mkdir();
	}
    	
	try {
	    fw = new FileWriter("stockdata//TimeAndSales_" + tStr + ".sto");
	    for(int i = 0; i<data.length; i++) {
		for(int j = 0; j<data[0].length; j++) {
		    fw.write(data[i][j] + " ");
		}
		fw.write("TimeAndSales_" + data[i][0] + "_" + tStr + "\r\n");
	    }
	    fw.close();    		
    	} catch (IOException e) {
	    e.printStackTrace();
	    return false;
    	}

    	for(int i = 0; i<allStock.length; i++) {
	    stock = allStock[i];
	    System.out.println(stock+"\n");
	    
	    stockString = "http://xml.island.com/ws/xml/timeandsales.xml?token="
		+ token + "&symbol=" + stock + "&recNumb=100" + "&time=" + timeStr;	
	    
	    try {
		fw = new FileWriter("stockdata//TimeAndSales_" + stock + "_" + tStr + ".txt");
	    } catch (Exception e) {
		e.printStackTrace();
		return false;
	    }
	    
	    do {
		xmls = new XMLStream(parent);
		try {
		    document = xmls.openStream(stockString);
		} catch (Exception exc) {
		    exc.printStackTrace();
		    return false;
		}
		
		if(document == null) return false;
    		
		recNumb = parseTimeAndSales();
		if(recNumb < 1) break;
    		
		try {
		    for(int k = 0; k<recNumb; k++)
			fw.write(stock + " " + data[k][0] + " " + data[k][1] + " " + data[k][2]
				 + " " + data[k][3] + " " + data[k][4] + "\r\n");
		} catch (IOException e) {
		    e.printStackTrace();
		}
    		
		String newTime = data[data.length-1][3];
		newTime = updateStockString(newTime.substring(0,newTime.length()));
		stockString = stockString.substring(0,stockString.length()-12) + newTime;
    		
	    } while(true);
	    
	    try {
		fw.close();
	    } catch (IOException e) {
		e.printStackTrace();
	    }
	}
	
	return true;
    }
    
    private String updateStockString(String s) {
	// Time format: HH:MM:SS.mmm decrement millisecond by 1
	StringTokenizer tok = new StringTokenizer(s, ":.");
	
	String hour = tok.nextToken();
	if(hour.startsWith("0")) {
	    hour = hour.substring(1);
	}
	int HH = Integer.parseInt(hour);
	
	String minute = tok.nextToken();
	if(minute.startsWith("0")) {
	    minute = minute.substring(1);
	}
	int MM = Integer.parseInt(minute);
	
	String second = tok.nextToken();
	if(second.startsWith("0")) {
	    second = second.substring(1);
	}
	int SS = Integer.parseInt(second);
	
	String msecond = tok.nextToken();
	while(msecond.startsWith("0") && msecond.length() > 1) {
	    msecond = msecond.substring(1);
	}
	int mmm = Integer.parseInt(msecond);
	
	int time = HH*60*60*1000 + MM*60*1000 + SS*1000 + mmm;
	time--;
	
	hour = String.valueOf(time/(60*60*1000));
	if(hour.length() == 1) {
	    hour = "0" + hour;
	}		
	
	minute = String.valueOf((time/(60*1000))%60);
	if(minute.length() == 1) {
	    minute = "0" + minute;
	}
	
	second = String.valueOf((time/1000)%60);
	if(second.length() == 1) {
	    second = "0" + second;
	}
	
	msecond = String.valueOf(time%1000);
	while(msecond.length() < 3) {
	    msecond = "0" + msecond;
	}
		
    	return hour + ":" + minute + ":" + second + "." + msecond;
    }
    
    public String[][] getData() {
    	return data;
    }
    
    private int parseTimeAndSales() {    
	NodeList list = document.getElementsByTagName("matchList").item(0).getChildNodes();
	int recNumb = Integer.parseInt(document.getElementsByTagName("matchList").item(0).
				       getAttributes().getNamedItem("recNumb").getNodeValue());
    	int size = recNumb;
	
	data = new String[size][5];
	Node node, child;
	// TODO:could use getNodeName() instead
	//      	String value;
	int count = 0;
	
	for(int i = 0; count<size; i++) {
	    node = list.item(i);
	    if(node.hasChildNodes()) {
		//value = node.getNodeValue();
		data[count][0] = node.getAttributes().getNamedItem("refNumb").getNodeValue();
		
		child = node.getFirstChild();
		node.removeChild(child);				
		child = node.getFirstChild();				
		data[count][1] = child.getFirstChild().getNodeValue();
		node.removeChild(child);
		
		child = node.getFirstChild();
		node.removeChild(child);				
		child = node.getFirstChild();
		data[count][2] = child.getFirstChild().getNodeValue();
		node.removeChild(child);
		
		child = node.getFirstChild();
		node.removeChild(child);				
		child = node.getFirstChild();
		String tTime = child.getFirstChild().getNodeValue();
		data[count][3] = tTime.substring(0,tTime.length()-6);
		node.removeChild(child);
		
		child = node.getFirstChild();
		node.removeChild(child);				
		child = node.getFirstChild();
		data[count][4] = child.getFirstChild().getNodeValue();
		node.removeChild(child);
		
		count++;
	    }
    	}
    	
    	return recNumb;
    }
    
    private void getTopListData() {
    	int size = Integer.parseInt(bufferSize);
	NodeList list = document.getElementsByTagName("stockList").item(0).getChildNodes();

	data = new String[size][2];
	Node node, child;
	int count = 0;
	
	for(int i = 0; count<size; i++) {
	    node = list.item(i);
	    if(node.hasChildNodes()) {
		data[count][0] = node.getAttributes().getNamedItem("symbol").getNodeValue();
		
		child = node.getFirstChild();
		node.removeChild(child);
		child = node.getFirstChild();
		node.removeChild(child);				
		child = node.getFirstChild();
		node.removeChild(child);				
		child = node.getFirstChild();
		node.removeChild(child);
		child = node.getFirstChild();
		node.removeChild(child);
		child = node.getFirstChild();
		node.removeChild(child);
		child = node.getFirstChild();
		node.removeChild(child);
		
		node = node.getFirstChild();
		child = node.getFirstChild();
		node.removeChild(child);
		child = node.getFirstChild();
		data[count][1] = child.getFirstChild().getNodeValue();
		
		count++;
	    }
    	}    
    }
}
