package ExStockData.XML;

import java.net.URL;
import java.net.HttpURLConnection;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import javax.swing.JFrame;
import javax.swing.JOptionPane;

import org.w3c.dom.Document;

import java.util.ArrayList;

import java.io.File;
import java.io.InputStreamReader;

public class XMLStream {
    private JFrame parent;
    
    public XMLStream() {
    }
    
    public XMLStream(JFrame parent) {
	this.parent = parent;
    }
    
    public Document openStream(String stockString) throws Exception {
	System.setProperty("sun.net.client.defaultConnectTimeout", String.valueOf("5000"));
	System.setProperty("sun.net.client.defaultReadTimeout", String.valueOf("6500"));
	
	URL url = new URL(stockString);
	HttpURLConnection conn = (HttpURLConnection)url.openConnection();
	
	DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
	DocumentBuilder builder = factory.newDocumentBuilder();
	Document document;
	try {
	    document = builder.parse(conn.getInputStream());
	} catch (Exception e) {
	    JOptionPane.showMessageDialog(parent,
	        "Unable to connect to INET stock data!");
	    JOptionPane.showMessageDialog(parent,
	        "Server is busy or token access (in \"ini/token.ini\") limit exceeded.");
	    document = null;
	}
	conn.disconnect();
	
	return document;
    }		
}
